Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
AnimGroup Class Reference

This is the base class for AnimChannel and AnimBundle. More...

`#include "animGroup.h"`

Inheritance diagram for AnimGroup:

## Public Member Functions
| AnimGroup (AnimGroup *parent, const std::string &name)
| Creates the AnimGroup, and adds it to the indicated parent.
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Takes in a vector of pointes to TypedWritable objects that correspond to all the requests for pointers that this object made to BamReader.
AnimGroup * | find_child (const std::string &name) const
| Returns the first descendant found with the indicated name, or NULL if no such descendant exists.
virtual TypeHandle | force_init_type ()
AnimGroup * | get_child (int n) const
AnimGroup * | get_child_named (const std::string &name) const
| Returns the first child found with the indicated name, or NULL if no such child exists.
int | get_num_children () const
virtual TypeHandle | get_type () const
virtual TypeHandle | get_value_type () const
| Returns the TypeHandle associated with the ValueType we are concerned with.
virtual void | output (std::ostream &out) const
| Writes a one-line description of the group.
void | sort_descendants ()
| Sorts the children nodes at each level of the hierarchy into alphabetical order.
virtual void | write (std::ostream &out, int indent_level) const
| Writes a brief description of the group and all of its descendants.
virtual void | write_datagram (BamWriter *manager, Datagram &me)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
static TypedWritable * | make_AnimGroup (const FactoryParams &params)
| Factory method to generate a AnimGroup object.
static void | register_with_read_factory ()
| Factory method to generate a AnimGroup object.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_child
| Returns the nth child of the group.
| get_num_children
| Returns the number of child nodes of the group.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This is the base class for AnimChannel and AnimBundle.

It implements a hierarchy of AnimChannels. The root of the hierarchy must be an AnimBundle.

Definition at line 33 of file animGroup.h.

## Constructor & Destructor Documentation

## ◆ AnimGroup()

AnimGroup::AnimGroup | ( | AnimGroup * | parent,
|  | const std::string & | name )
| explicit

Creates the AnimGroup, and adds it to the indicated parent.

The only way to delete it subsequently is to delete the entire hierarchy.

Definition at line 67 of file animGroup.cxx.

## ◆ ~AnimGroup()

AnimGroup::~AnimGroup | ( |  | ) |
| virtual

Definition at line 81 of file animGroup.cxx.

## Member Function Documentation

## ◆ complete_pointers()

int AnimGroup::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager )
| virtual

Takes in a vector of pointes to TypedWritable objects that correspond to all the requests for pointers that this object made to BamReader.

Reimplemented from TypedWritable.

Reimplemented in AnimChannelMatrixDynamic, and AnimChannelScalarDynamic.

Definition at line 276 of file animGroup.cxx.

Referenced by AnimChannelMatrixDynamic::complete_pointers(), and AnimChannelScalarDynamic::complete_pointers().

## ◆ find_child()

AnimGroup * AnimGroup::find_child | ( | const std::string & | name | ) | const

Returns the first descendant found with the indicated name, or NULL if no such descendant exists.

This method searches the entire graph beginning at this AnimGroup; see also get_child_named().

Definition at line 128 of file animGroup.cxx.

References find_child().

Referenced by find_child().

## ◆ force_init_type()

virtual TypeHandle AnimGroup::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 90 of file animGroup.h.

## ◆ get_child_named()

AnimGroup * AnimGroup::get_child_named | ( | const std::string & | name | ) | const

Returns the first child found with the indicated name, or NULL if no such child exists.

This method searches only the children of this particular AnimGroup; it does not recursively search the entire graph. See also find_child().

Definition at line 110 of file animGroup.cxx.

Referenced by PartGroup::check_hierarchy().

## ◆ get_class_type()

static TypeHandle AnimGroup::get_class_type | ( |  | ) |
| inline static

Definition at line 92 of file animGroup.h.

## ◆ get_type()

virtual TypeHandle AnimGroup::get_type | ( |  | ) | const
| inline virtual

Reimplemented from TypedWritableReferenceCount.

Definition at line 87 of file animGroup.h.

## ◆ get_value_type()

TypeHandle AnimGroup::get_value_type | ( |  | ) | const
| virtual

Returns the TypeHandle associated with the ValueType we are concerned with.

This is provided to allow a bit of run-time checking that joints and channels are matching properly in type.

Reimplemented in AnimChannel< SwitchType >, AnimChannel< ACMatrixSwitchType >, AnimChannel< ACMatrixSwitchType >, AnimChannel< ACScalarSwitchType >, AnimChannel< ACScalarSwitchType >, AnimChannelBase, ValueType< SwitchType >, and ValueType< SwitchType >.

Definition at line 175 of file animGroup.cxx.

Referenced by PartGroup::check_hierarchy().

## ◆ init_type()

static void AnimGroup::init_type | ( |  | ) |
| inline static

Definition at line 95 of file animGroup.h.

## ◆ make_AnimGroup()

TypedWritable * AnimGroup::make_AnimGroup | ( | const FactoryParams & | params | ) |
| static

Factory method to generate a AnimGroup object.

Definition at line 293 of file animGroup.cxx.

References parse_params().

Referenced by register_with_read_factory(), and write_datagram().

## ◆ output()

void AnimGroup::output | ( | std::ostream & | out | ) | const
| virtual

Writes a one-line description of the group.

Reimplemented in AnimBundle, AnimChannelFixed< SwitchType >, and AnimChannelMatrixFixed.

Definition at line 183 of file animGroup.cxx.

Referenced by AnimChannelFixed< SwitchType >::output(), and AnimChannelMatrixFixed::output().

## ◆ register_with_read_factory()

void AnimGroup::register_with_read_factory | ( |  | ) |
| static

Factory method to generate a AnimGroup object.

Definition at line 307 of file animGroup.cxx.

References BamReader::get_factory(), make_AnimGroup(), and Factory< Type >::register_factory().

## ◆ sort_descendants()

void AnimGroup::sort_descendants | ( |  | ) |

Sorts the children nodes at each level of the hierarchy into alphabetical order.

This should be done after creating the hierarchy, to guarantee that the correct names will match up together when the AnimBundle is later bound to a PlayerRoot.

Definition at line 159 of file animGroup.cxx.

## ◆ write()

void AnimGroup::write | ( | std::ostream & | out,
|  | int | indent_level ) const
| virtual

Writes a brief description of the group and all of its descendants.

Reimplemented in AnimChannelMatrixXfmTable, and AnimChannelScalarTable.

Definition at line 191 of file animGroup.cxx.

References indent().

## ◆ write_datagram()

virtual void AnimGroup::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from TypedWritable.

Reimplemented in AnimBundle, AnimChannelBase, AnimChannelMatrixDynamic, AnimChannelMatrixFixed, AnimChannelMatrixXfmTable, AnimChannelScalarDynamic, and AnimChannelScalarTable.

References make_AnimGroup().

Referenced by AnimChannelBase::write_datagram().

## Member Data Documentation

## ◆ get_child

AnimGroup * AnimGroup::get_child

Returns the nth child of the group.

Definition at line 45 of file animGroup.h.

Referenced by PartGroup::check_hierarchy().

## ◆ get_num_children

int AnimGroup::get_num_children

Returns the number of child nodes of the group.

Definition at line 45 of file animGroup.h.

Referenced by PartGroup::check_hierarchy().

The documentation for this class was generated from the following files:

- panda/src/chan/animGroup.h
- panda/src/chan/animGroup.cxx